#ifndef PTACI_H
#define PTACI_H

#include <stdio.h>
#include <stdlib.h>

#define POCETPTAKU	100

const char *datafilename = "ptaci.bin";

int ptaci_x[POCETPTAKU];
int ptaci_y[POCETPTAKU];
int ptaci_udalost[POCETPTAKU];

#pragma align=1
typedef struct {
    short x;
    short y;
} ptaci_t;
#pragma align=0

FILE *data = NULL;

int nacti_dalsi_zaznamy()
{
    char s[256];
    int i; //, c, p, x, y, u, prvnicas;
    ptaci_t pozice;
    unsigned char pack;
    unsigned long delka;
    
    if (data == NULL) {
	if ((data = fopen( datafilename, "rb")) == NULL) {
	    fprintf( stderr, "Nelze nacist soubor '%s'.\n", datafilename);
	    exit(1);
	}
	fread( &delka, sizeof(delka), 1, data);
	for (i=0; i<POCETPTAKU; i++) {
	    if (fread( &pozice, sizeof(pozice), 1, data) != 1) {
		if (i == 0) {
		    fclose(data);
		    data = NULL;
		    return 0;
		}
		fprintf( stderr, "Soubor byl poskozen.\n");
		exit(1);
	    }
	    ptaci_x[i] = pozice.x;
	    ptaci_y[i] = pozice.y;
	    ptaci_udalost[i] = 0;
	}
	return 1;
    }
    for (i=0; i<POCETPTAKU; i++) {
	if (fread( &pack, sizeof(pack), 1, data) != 1) {
	    if (i == 0) {
		fclose(data);
		data = NULL;

		return 0;
	    }
	    fprintf( stderr, "Nekdo ukradl cast simulacnich dat.\n");
	    exit(1);
	}
	if (pack == 0xFF) {
	    ptaci_udalost[i] = 1;
	    pack = (4<<4)+4;
	}
	else ptaci_udalost[i] = 0;

	ptaci_x[i] += (pack & 0x0F) - 4;
	ptaci_y[i] += ((pack >> 4) & 0x0F) - 4;
    }
    return 1;
}

unsigned long zjisti_delku_simulace()
{
    FILE *f = NULL;
    unsigned long delka, l;

    if ((f = fopen( datafilename, "r")) == NULL) {
	    fprintf( stderr, "Nelze nacist soubor s daty.\n");
	    exit(1);
    }
    fread( &delka, sizeof(delka), 1, f);
    
    fseek( f, 0, SEEK_END);
    l = ftell(f);
    fclose(f);
    l -= POCETPTAKU * sizeof(ptaci_t) + sizeof(long); // hlavicka

    if ((l % POCETPTAKU) != 0) {
	    fprintf( stderr, "Chybny format simulacni dat.\n");
	    exit(1);
    }
    if (l / POCETPTAKU != delka) {
	    fprintf( stderr, "V souboru chybi cast simulacni dat.\n");
	    exit(1);
    }
    return delka;
}

#endif
